## Gallery info v1.01
## made by jedi
## http://jedi.postboks.org
## #eod on irc.eod.cc
##
## Fetch last image and last comments from 
## a gallery page, and display info at the
## irc-channel

##############
## Config ####

## the files where data is saved
set commentfile "logs/comments.db"
set shotsfile "logs/shots.db"

## How should the bot announce new stuff ?
## 0 = Channels only
## 1 = Nicklist only
## 2 = Both Channels and NickList
set galannounce "0"

## On which channels should the script be active ?
## "" for all channels the bot are one.
set galchan "#eod #root.no"

## Which users should get messages in msg ?
set galnicks "NiTR8\^ jedi"

## How many comments/shots should be stored ?
set shotslimit "10"
set commentslimit "10"

## Url to the gallery
set galleryurl "http://nitrate.mine.nu/gallery"

## How ofte should we check the gallery (in minutes)
set galleryupdate "5"

## End Of Config ####
#############################################
## Don't touch anything below this line !! ##
#############################################

bind pub - !lastcomments gallery_lastcomments
bind pub - !lastshots gallery_lastshots

proc gallery_lastcomments {nick uhost hand chan arg} {
   global commentfile commentslimit

   set count 0
   if { [lindex $arg 0] < 1 } { 
     set max $commentslimit
   } else {
     set max [lindex $arg 0]
     if { $max > $commentslimit } { set max "$commentslimit" }
   }
   
   
   putserv "privmsg $chan :\[Gallery\] Show last $max comments";
   
   set temp [open "$commentfile" r]
   while {[eof $temp] != 1} {
      set newcomment [gets $temp]
      incr count
      
      if { $count > $max } { return 0; }
      
      set url [lindex [split "$newcomment" ";"] 0]
      set commenter [lindex [split "$newcomment" ";"] 1]

      putserv "privmsg $chan :\[Gallery\]  $count. From \002$commenter\002 on ->\[ $url \]<-";
  
   }
   close $temp

}

proc gallery_lastshots {nick uhost hand chan arg} {
   global shotsfile shotslimit

   set count 0
   if { [lindex $arg 0] < 1 } { 
     set max $shotslimit
   } else {
     set max [lindex $arg 0]
     if { $max > $shotslimit } { set max "$shotslimit" }
   }
   
   
   putserv "privmsg $chan :\[Gallery\] Show last $max pictures";
   
   set temp [open "$shotsfile" r]
   while {[eof $temp] != 1} {
      set newshot [gets $temp]
      incr count
      
      if { $count > $max } { return 0; }
      
      putserv "privmsg $chan :\[Gallery\]  $count. $newshot";
  
   }
   close $temp

}


proc gallery_check { } {
    global galleryupdate

    gallery:comments
    gallery:shots
    timer $galleryupdate gallery_check
    return 1
}

proc gallery:comments { } {
   global commentfile galchan commentslimit galleryurl galnicks galannounce

   set lastcomment ""   
   if {[file exists $commentfile]} {
     set temp [open "$commentfile" r]
     set lastcomment "[gets $temp]"
     close $temp
   }
   if {$lastcomment == ""} { set lastcomment "none" }
   
   set temp [open "$commentfile" w+]
   set lastoutput [exec php scripts/galleryparser.php comments $galleryurl $commentslimit]
   puts $temp "$lastoutput"
   close $temp
   
   if {$lastcomment == "none"} { putlog "comment db created"; return 0 }
   set temp [open "$commentfile" r]
   while {[eof $temp] != 1} {
      set newcomment [gets $temp]
      if {($lastcomment == $newcomment)} { return 0; }
      set url [lindex [split "$newcomment" ";"] 0]
      set commenter [lindex [split "$newcomment" ";"] 1]
      
      if { $galannounce == "0" || $galannounce == "2" } {
      	foreach chan [channels] {

          if { $galchan == "" } {
            putserv "privmsg $chan :\[Gallery\] There is a new comment from \002$commenter\002 on ->\[ $url \]<-";
          } else {
            if {[lsearch -exact [string tolower $galchan] [string tolower $chan]] != -1 } {
              putserv "privmsg $chan :\[Gallery\] There is a new comment from \002$commenter\002 on ->\[ $url \]<-";
            }
          }
        }
      }

      if { $galannounce == "1" || $galannounce == "2" } {
        foreach nick $galnicks { 
          if { [isonchan $nick] == "1" } {
              putserv "privmsg $nick :\[Gallery\] There is a new comment from \002$commenter\002 on ->\[ $url \]<-";
              putlog "Sending to $nick"
          }
        }
      }
   
   }
   close $temp


}

proc isonchan { chk_nick } {
   foreach chan [channels] {
     foreach nick [chanlist $chan] {
      if { $chk_nick == $nick } {
        return 1;
      }
     }
   }
   return 0;
}

proc gallery:shots { } {

   global shotsfile galchan shotslimit galleryurl galnicks galannounce

   set lastshot ""
   if {[file exists $shotsfile]} {
     set temp [open "$shotsfile" r]
     set lastshot "[gets $temp]"
     close $temp
   }
   if {$lastshot == ""} { set lastshot "none" }
   
   set temp [open "$shotsfile" w+]
   set lastoutput [exec php scripts/galleryparser.php shots $galleryurl $shotslimit]
   puts $temp "$lastoutput"
   close $temp
   
   if {$lastshot == "none"} { putlog "shots db created"; return 0 }
   set temp [open "$shotsfile" r]
   while {[eof $temp] != 1} {
      set newshot [gets $temp]
      if {($lastshot == $newshot)} { return 0; }

      if { $galannounce == "0" || $galannounce == "2" } {      
        foreach chan [channels] {
          if { $galchan == "" } {
            putserv "privmsg $chan :\[Gallery\] New picture ->\[ $newshot \]<-";
          } else {
            if {[lsearch -exact [string tolower $galchan] [string tolower $chan]] != -1 } {
              putserv "privmsg $chan :\[Gallery\] New picture ->\[ $newshot \]<-";
            }
          }
        }
      }

      if { $galannounce == "1" || $galannounce == "2" } {
        foreach nick $galnicks { 
          if { [isonchan $nick] == "1" } {
            putserv "privmsg $nick :\[Gallery\] New picture ->\[ $newshot \]<-";
          }
        }
      }
   }
   close $temp
}

if {![info exists gallery_checking]} {
  timer $galleryupdate gallery_check
  set gallery_checking 1
}                                      
   
putlog "Gallery info v1.01 by jedi *L*O*A*D*E*D";
